'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDatetime = require('react-datetime');

var _reactDatetime2 = _interopRequireDefault(_reactDatetime);

var _FormGroup = require('./FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

require('react-datetime/css/react-datetime.css');

var DateRangeFormGroup = function (_React$Component) {
  _inherits(DateRangeFormGroup, _React$Component);

  function DateRangeFormGroup(props) {
    _classCallCheck(this, DateRangeFormGroup);

    var _this = _possibleConstructorReturn(this, (DateRangeFormGroup.__proto__ || Object.getPrototypeOf(DateRangeFormGroup)).call(this, props));

    _this.state = {
      fromName: 'dateRange_' + _this.props.id + '_From',
      thruName: 'dateRange_' + _this.props.id + '_Thru'
    };

    _this.fromChange = _this.fromChange.bind(_this);
    _this.thruChange = _this.thruChange.bind(_this);
    return _this;
  }

  _createClass(DateRangeFormGroup, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        fromName: 'dateRange_' + nextProps.id + '_From',
        thruName: 'dateRange_' + nextProps.id + '_Thru'
      });
    }
  }, {
    key: 'fromChange',
    value: function fromChange(selectedDate) {
      this.props.onChange({
        target: {
          id: this.state.fromName,
          value: selectedDate
        }
      });
    }
  }, {
    key: 'thruChange',
    value: function thruChange(selectedDate) {
      this.props.onChange({
        target: {
          id: this.state.thruName,
          value: selectedDate
        }
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          dateFormat = _props.dateFormat,
          error = _props.error,
          fromValue = _props.fromValue,
          id = _props.id,
          label = _props.label,
          required = _props.required,
          thruValue = _props.thruValue;

      var requiredText = '';
      if (required) {
        requiredText = _react2.default.createElement(
          'small',
          { className: 'text-danger' },
          'Required'
        );
      }
      return _react2.default.createElement(
        _FormGroup2.default,
        { error: error, id: id, label: label, required: required },
        _react2.default.createElement(
          'div',
          { className: 'row' },
          _react2.default.createElement(
            'div',
            { className: 'col-md-6' },
            _react2.default.createElement(
              'label',
              { className: 'control-label', htmlFor: this.state.fromName },
              'From ',
              requiredText
            ),
            _react2.default.createElement(_reactDatetime2.default, { id: this.state.fromName, name: this.state.fromName, value: fromValue,
              onChange: this.fromChange, dateFormat: dateFormat, timeFormat: false })
          ),
          _react2.default.createElement(
            'div',
            { className: 'col-md-6' },
            _react2.default.createElement(
              'label',
              { className: 'control-label', htmlFor: this.state.thruName },
              'Thru ',
              requiredText
            ),
            _react2.default.createElement(_reactDatetime2.default, { id: this.state.thruName, name: this.state.thruName, value: thruValue,
              onChange: this.thruChange, dateFormat: dateFormat, timeFormat: false })
          )
        )
      );
    }
  }]);

  return DateRangeFormGroup;
}(_react2.default.Component);

exports.default = DateRangeFormGroup;


DateRangeFormGroup.defaultProps = {
  disabled: false,
  required: false
};

DateRangeFormGroup.propTypes = {
  dateFormat: _propTypes2.default.bool,
  error: _propTypes2.default.string,
  fromValue: _propTypes2.default.string.isRequired,
  id: _propTypes2.default.string.isRequired,
  label: _propTypes2.default.string.isRequired,
  onChange: _propTypes2.default.func.isRequired,
  required: _propTypes2.default.bool,
  thruValue: _propTypes2.default.string.isRequired
};